import Foundation
import Bow

public extension Option {
    static func traversal() -> Traversal<OptionOf<A>, A> {
        return OptionTraversal<A>()
    }

    static func each() -> EachInstance<A> {
        return EachInstance<A>()
    }

    private class OptionTraversal<A> : Traversal<OptionOf<A>, A> {
        override func modifyF<F: Applicative>(_ s: OptionOf<A>, _ f: @escaping (A) -> Kind<F, A>) -> Kind<F, OptionOf<A>> {
            return s.traverse(f)
        }
    }

    class EachInstance<E> : Each {
        public typealias S = OptionOf<E>
        public typealias A = E

        public func each() -> Traversal<OptionOf<E>, E> {
            return Option<E>.traversal()
        }
    }
}

